# Getscreen.me Gateway

This is a small service working in your company's local network for seamless integration with Getscreen.me service (self-hosted or Cloud). Gateway should be installed on Windows or Linux server in your network which has constant and reliable connection to Getscreen.me Cloud or self-host Getscreen server. 

* Connect Getscreen.me with your local Active Directory 
* Act as proxy server to accelerated connections within your network (coming soon)
* Wake up your computers via Wake-on-LAN without public IP addresses (coming soon)

## Installation and Configuration of the Utility

Management is performed using command line and a configuration file.

### Installation

Create folder for service, e.g. `C:\Getscreen\Gateway`. 
Copy files `gateway.exe` and `config.json` into that folder.
Run command:

```
gateway.exe -install
```

### Configuration

Edit `config.json` configuration file, located in the same folder with `gateway.exe` file and replace parameters with your data, as described below. Mandatory fields are marked with an asterisk.

| Parameter                 | Type      | Description |
| ------------------------- | --------- | -------- |
| `server.host` *           | `string`  | Getscreen.me server address |
| `server.token` *          | `string`  | Token for authenticating the gateway with your account. The token is generated in the personal account on the [settings page](https://getscreen.me/dashboard/settings/tokens). |
| `server.secure`           | `boolean` | Server certificate verification. Default is `true`. |
| `ldap.url` *              | `string`  | AD server address for LDAP connection (with the `ldaps://` protocol). |
| `ldap.user` *             | `string`  | Administrator login for connecting to the AD server. |
| `ldap.password` *         | `string`  | Administrator password for connecting to the AD server. |
| `ldap.filter`             | `string`  | Additional filter for obtaining the list of AD groups. |
| `ldap.login-attribute`    | `string`  | LDAP attribute for selecting the field by which the user's email will be determined. |
| `ldap.secure`             | `boolean` | AD server certificate verification. Default is `true`. |

### Starting the Service

After installation and configuration, it is necessary to start the service using the following command:

```
gateway.exe -start
```

If configured correctly, when launched in console mode, you should see logs similar to the following:

*Successful establishment of connection with Getscreen.me server:*

```
13:51:55.731	INFO	Signaling       connected to signaling server getscreen.me
```

You can also view the status of the connected gateway in your personal account under the token list.

*Successful establishment of connection with your AD server:*

```
13:51:56.059	INFO	LDAP            connected to 'ldaps://10.51.11.34' as 'ADFS\Administrator' base: 'DC=ADFS,DC=TEST,DC=ME'
```

### Gateway Management Commands

| Command                   | Description               |
| ------------------------- | ------------------------- |
| `gateway.exe -install`    | Service installation      |
| `gateway.exe -uninstall`  | Service uninstallation    |
| `gateway.exe -start`      | Starting the service      |
| `gateway.exe -stop`       | Stopping the service      |
